
#include "equation.h"
#include "chaos.h"

///::title:: Riemann initial data with uniformly random shock location
///::vars:: NX=512 MAXT=0.1
///::consts:: MAXX=2 N_UNIFORM=1 N_NORMAL=0
///::bc:: NEUMANN

void init_cell(PrimitiveVars &v, real x, real y, real z)
{
  if (x < 0.9 + 0.2*chaos.uniform[0])
    v.u = 2.0;
  else
    v.u = 1.0;
}