
#include "equation.h"
#include "chaos.h"

///::title:: Sod shock tube
///::vars:: NX=512
///::consts:: MAXX=2.0 MAXT=0.5
///::consts:: N_UNIFORM=1 N_NORMAL=0
///::bc:: NEUMANN

void init_cell(PrimitiveVars &v, real x, real y, real z)
{
  if (x < 1.0 + 0.1*chaos.uniform[0]) {
    v.rho = 3.0;
    v.u[X] = 0.0;
    v.p = 3.0;
  } else {
    v.rho = 1.0;
    v.u[X] = 0.0;
    v.p = 1.0;
  }
}
