
#include "main.h"
#include "chaos.h"

///::title:: Tsunami (1D version)
///::vars:: NX=512 MAXT=0.53 BED_OFFSET=0.0
///::vars:: PEAK=0.05 LOCATION=1.8 WIDTH=0.1
///::consts:: MAXX=2 N_UNIFORM=1 N_NORMAL=0
///::macro:: SOURCE_HOOK topography.h compute_source(i,j);
///::bc:: NEUMANN

void init_cell(PrimitiveVars &v, real x, real y, real z)
{
  v.h = 2.0;
  if (x > LOCATION - WIDTH && x < LOCATION + WIDTH)
    v.h += PEAK*cos(1/(2*WIDTH)*pi*(x-LOCATION))*chaos.uniform[0];
  v.h -= b(x,y);
  if (v.h < 0.0) v.h = 0.0;
}
