
#include "main.h"
#include "chaos.h"

///::title:: Wave equation with stochastic density (1D version)
///::vars:: NX=128 MAXT=2.0
///::consts:: MAXX=2 N_UNIFORM=1 N_NORMAL=0
///::bc:: REPEAT

// u_0     = sin(pi*x);
// (u_0)_t = 0.0;

// TODO: non-constant rho is NOT implemented yet!
void init_cell(PrimitiveVars &v, real x, real y, real z)
{
  v.v[0] = pi*cos(pi*x);
  v.w    = 0.0;
  v.k    = 1.0;
  v.rho  = 2.0 + sin(pi*x)*chaos.uniform[0];
}
