
#include "main.h"
#include "hll_util.h"
#include "solver.h"

///::title:: HLL solver (standard 2 wave) | for Linear Advection
///::depends:: hll_util-linadv
///::consts:: HLL_dt=1

void solver_calc_flux(ConservedVars &F, vector &us, vector &Bs,
                      const AllVariables &lV, const AllVariables &rV,
                      int i, int j, int k, int d)
{
  real sl, sr, cs;
  hll_speeds(lV, rV, d, sl, sr, cs);
  if (sl > 0) calc_point_flux(F, lV, d);
  else if (sr < 0) calc_point_flux(F, rV, d);
  else {
    ConservedVars lF, rF;

    calc_point_flux(lF, lV, d);
    calc_point_flux(rF, rV, d);
    F = (sr*lF - sl*rF + sr*sl*(rV.U - lV.U))/(sr-sl);
  }
}
