
#include "include.h"
#include "structures.h"

// === ConservedVars

// member operators

void ConservedVars::operator += (const ConservedVars &a) {
  for (int m=0; m<SIZE_CV; m++)
    realCast(*this) [m] += realCast(a) [m];
}

void ConservedVars::operator -= (const ConservedVars &a) {
  for (int m=0; m<SIZE_CV; m++)
    realCast(*this) [m] -= realCast(a) [m];
}

void ConservedVars::operator *= (const ConservedVars &a) {
  for (int m=0; m<SIZE_CV; m++)
    realCast(*this) [m] *= realCast(a) [m];
}

void ConservedVars::operator /= (const ConservedVars &a) {
  for (int m=0; m<SIZE_CV; m++)
    realCast(*this) [m] /= realCast(a) [m];
}

void ConservedVars::operator /= (const real r) {
  for (int m=0; m<SIZE_CV; m++)
    realCast(*this) [m] /= r;
}

void ConservedVars::operator *= (const real r) {
  for (int m=0; m<SIZE_CV; m++)
    realCast(*this) [m] *= r;
}

void ConservedVars::operator = (const real r) {
  for (int m=0; m<SIZE_CV; m++)
    realCast(*this) [m] = r;
}

#if COMPUTE_KURTOSIS
void ConservedVars::operator -= (const real r) {
  for (int m=0; m<SIZE_CV; m++)
    realCast(*this) [m] -= r;
}
#endif

// === XtraVars

// member operators

void XtraVars::operator += (const XtraVars &a) {
  for (int m=0; m<SIZE_XV; m++)
    realCast(*this) [m] += realCast(a) [m];
}

void XtraVars::operator -= (const XtraVars &a) {
  for (int m=0; m<SIZE_XV; m++)
    realCast(*this) [m] -= realCast(a) [m];
}
  
void XtraVars::operator *= (const XtraVars &a) {
  for (int m=0; m<SIZE_XV; m++)
    realCast(*this) [m] *= realCast(a) [m];
}
  
void XtraVars::operator /= (const XtraVars &a) {
  for (int m=0; m<SIZE_XV; m++)
    realCast(*this) [m] /= realCast(a) [m];
}

void XtraVars::operator /= (const real r) {
  for (int m=0; m<SIZE_XV; m++)
    realCast(*this) [m] /= r;
}

void XtraVars::operator *= (const real r) {
  for (int m=0; m<SIZE_XV; m++)
    realCast(*this) [m] *= r;
}

void XtraVars::operator = (const real r) {
  for (int m=0; m<SIZE_XV; m++)
    realCast(*this) [m] = r;
}

#if COMPUTE_KURTOSIS
void XtraVars::operator -= (const real r) {
  for (int m=0; m<SIZE_XV; m++)
    realCast(*this) [m] -= r;
}
#endif
