
#include "topography.h"

#include "equation.h"
#include "multi.h"
#include "chaos.h"

///::title:: Karhunen-Loeve expansion (1D version)
///::vars:: BED_OFFSET=0.0 KL=16
///::consts:: T_UNIFORM=KL T_NORMAL=0

real b (real x, real y) {
  // Karhunen–Loeve expansion for topography b consisting of KL basis functions
  real value = BED_OFFSET;
  for (int m=1; m<=KL; m++)
    value += 0.1 * pow(m,-1.1) * sin(m*pi*x) * (2*chaos.t_uniform[m-1] - 1);
  return value;
}
