
#include "topography.h"

#include "equation.h"
#include "multi.h"
#include "chaos.h"

#include "wavelet.h"

///::title:: Haar wavelet expansion (2D version)
///::vars:: BED_OFFSET=0.0 WL=L0+L
///::consts:: T_UNIFORM=(1<<(2*WL)) T_NORMAL=0
///::depends:: wavelet

real b (real x, real y) {
  
  long_int counter = 0;
  real value = BED_OFFSET * ( 1 + 0.1*(2*chaos.t_uniform[counter] - 1) );
  counter++;
  
  // Haar wavelet expansion for topography b consisting of Haar wavelet basis functions
  
  for (int m=1; m<=WL; m++) {
    for (int j=0; j<(1<<(m-1)); j++) {
      for (int j_=0; j_<(1<<(m-1)); j_++) {
        value += 0.1 * pow(m,-1.1) * wavelet(x/MAXX,m,j) * (2*chaos.t_uniform[counter] - 1);
        counter++;
      }
    }
  }
  return value;
}
