
#include "wavelet.h"

real wavelet (real x, const int &m, const int &j) {
  
  if (m == 0)
    return 1.0;
  
  // find if x is in the support; if not, retrun 0.0
  if ( (x < ((float)j)/(1<<(m-1))) || (x > ((float)(j+1))/(1<<(m-1))) )
    return 0.0;
  
  // else, map x onto reference wavelet scales
  for (int i=0; i<m-1; i++) {
    if (x < 0.5)
      x *= 2;
    else
      x = (x - 0.5) * 2;
  }
  
  // compute the value
  if (x < 0.5)
    return 1.0;
  else
    return -1.0;
}
